#extension GL_OES_EGL_image_external : require

precision mediump float;

// 纹理对象并不是直接绑定到shader上的（事实上是采样阶段发生的地方），而是绑定到‘纹理单元’上，‘纹理单元’的索引会被传到shader中，因此shader是通过纹理单元得到纹理对象的。
// 一般可以同时有多个可用的纹理单元，数量上限取决于显卡的容量。为了将一个纹理对象A绑定到纹理单元0上，首先你需要激活纹理单元0然后绑定纹理对象A。
// 定义一个OES纹理采样器
uniform samplerExternalOES uTextureUnit;

varying vec2 vTextureCoordinates; // 和顶点着色器中的定义一致

void main() {
    // texture2D是从uTextureUnit纹理中的vTextureCoordinates纹理坐标处，取纹素，也就是颜色
    // *vColor，代表纹理图片和颜色混合
    gl_FragColor = texture2D(uTextureUnit, vTextureCoordinates);
}