#extension GL_OES_EGL_image_external : require

precision mediump float;

// 定义一个2D纹理采样器，外部代码需要绑定一个图片
//uniform sampler2D uTextureUnit;
uniform samplerExternalOES uTextureUnit;

varying vec4 vColor;
varying vec2 vTextureCoordinates;

// 滤镜效果，0-原图，1-黑白，2-暖色，3-冷色
uniform int uTypeIndex;

void main() {
    //gl_FragColor = vColor;
    // texture2D是从uTextureUnit纹理中的vTextureCoordinates纹理坐标处，取纹素，也就是颜色
    // *vColor，代表纹理图片和颜色混合
    vec4 color = texture2D(uTextureUnit, vTextureCoordinates);// * vColor;
    if (uTypeIndex == 0) {
        gl_FragColor = color;
    } else if (uTypeIndex == 1) {
        float c = color.r * vColor.r + color.g * vColor.g + color.b * vColor.b;
        gl_FragColor = vec4(c, c, c, 1.0);
    } else {
        vec4 newColor = color + vColor;
        gl_FragColor = newColor;
    }
}